<template>
  <div>
    <ob-tabs>
      <ob-tabs-pane title="Бортовые блоки" :is-selected="true">
        <ob-table
          ref="bb-table"
          :remote-opt="{
            method: getDevices,
          }"
          :columns="columns"
          :functional-panel="true"
          :show-add-button="true"
          addButtonText="Добавить бортовой блок"
          :is-functional-group="false"
          :is-functional-sort="false"
          @add="onAdd"
          @select="onSelect"
        >
          <template v-slot:extraFuncToPanel>
          <div class="table-filters">
            <div class="table-filter hardcode">
              <span>Перевозчик: </span>
              <ob-inline-select
                v-model="filterContractor.uuid"
                :items="contractors"
              />
            </div>
          </div>
        </template>
        </ob-table>
      </ob-tabs-pane>
      <ob-tabs-pane title="Телефоны">
        Телефоны
      </ob-tabs-pane>
    </ob-tabs>
    <ob-modal
      ref="ob-modal-block-add"
      size="medium"
      :title-second="isNew ? 'Добавление' : 'Просмотр'" 
      title="Бортовой блок"
      @closed="resetModal"
    >
      <block ref="blockForm" :selectedBlock="selectedBlock" :isNew="isNew" @submit="onBlockSubmit" @close="$refs['ob-modal-block-add'].close()" />
    </ob-modal>
  </div>
</template>

<script>
import { mapGetters } from 'vuex';
import api from '@/api';

import obTabs from 'common-components/src/obComponents/obTabs';
import ObTabsPane from "common-components/src/obComponents/obTabs/ObTabsPane";
import obTable from 'common-components/src/obComponents/obTable';
import obInlineSelect from 'common-components/src/obComponents/obInlineSelect';
import obModal from 'common-components/src/obComponents/obModal';
import block from './components/block.vue';
  export default {
    name: 'trackingDevices',

    components: {
      obTabs,
      ObTabsPane,
      obTable,
      obInlineSelect,
      obModal,
      block
    },

    data() {
      return {
        tabs: [
          {
            title: "Бортовые блоки",
            id: 1
          },
          {
            title: "Телефоны",
            id: 2
          }
        ],
        selectedBlock: null,
        filterContractor: {
          title: 'Все',
          uuid: 'ALL'
        },
        contractors: [
          {
            title: 'Все',
            uuid: 'ALL'
          },
          {
            title: 'ООО "ОБОЗ ДИДЖИТАЛ"',
            uuid: '2'
          }
        ],
      }
    },

    computed: {
      ...mapGetters({
        isModerator: "user/isModerator"
      }),
      columns() {
        return [
          {
            title: "регномер ТС",
            key: "vehicleNumber",
          },
          {
            title: "№ бортового блока",
            key: "imei",
            width: "500"
          },
          {
            title: "тип тс",
            key: "vehicleType",
            html: ({ vehicleType }) => {
              const typesMap = {
                "TRUCK": "Тягач или фургон",
                "TRAILER": "Прицеп"
              }
              return `${typesMap[vehicleType]}`
            }
          },
          ...(this.isModerator ?
            [{
              title: "Перевозчик",
              key: "carriers",
              html: ({ carriers }) => {
                return carriers ? carriers.map(carrier => carrier.title).join(', ') : '—';
              }
            }] : []),
          {
            title: "последняя координата получена",
            key: "lastPositionAt",
            html: ({ lastPositionAt }) => {
              if (!lastPositionAt) {
                return "—"
              }

              const lastDate = new Date(lastPositionAt)

              const timeOptions = {
                hour: '2-digit',
                minute: '2-digit'
              };

              const isToday = () => {
                const today = new Date()
                return lastDate.getDate() == today.getDate() &&
                  lastDate.getMonth() == today.getMonth() &&
                  lastDate.getFullYear() == today.getFullYear()
              }

              const isYestarday = () => {
                const today = new Date()
                return lastDate.getDate() == today.getDate() - 1 &&
                  lastDate.getMonth() == today.getMonth() &&
                  lastDate.getFullYear() == today.getFullYear()
              }

              const date = isToday() ? "Сегодня" : isYestarday() ? "Вчера" : new Date(lastPositionAt).toLocaleDateString('ru-RU');

              const time = new Date(lastPositionAt).toLocaleTimeString('ru-RU', timeOptions);

              return `<div class="date"><p>${date}</p><span>${time}</span></div>`
            }
          }
        ]
      },

      isNew() {
        return !this.selectedBlock
      }
    },

    methods: {
      async getDevices() {
        try {
          const res = await api.tracking.getBlocksList();
          return res;
        } catch (err) {
          console.error(err);
        }
      },

      onAdd() {
        this.$refs["ob-modal-block-add"].open();
      },

      onSelect(item) {
        this.selectedBlock = item;
        this.$refs["ob-modal-block-add"].open();
      },

      resetModal() {
        this.selectedBlock = null;
        this.$refs.blockForm.onClose();
      },

      onBlockSubmit() {
        this.$refs["ob-modal-block-add"].close();
        this.loadData('bb-table');
      },

      loadData(refName) {
        this.$nextTick(() => {
          this.$refs[refName].loadData({ init: true });
        });
      },
    }
  }
</script>

<style lang="scss" scoped>
@import "~common-components/src/static/css/variables";
@import "~common-components/src/static/css/mixins";

.table-filters {
  display: flex;
  align-items: center;
  width: 100%;
}

.table-filter {
  background: $blue-150;
  border-radius: 19px;
  padding: 5px 9px;
  font-size: 14px;
  line-height: 18px;
  letter-spacing: 0.2px;
  color: $shale-gray;
  margin-right: 22px; 
}

::v-deep {
  td {
    &:first-child, &:nth-child(2) {
      white-space: nowrap;
    }

    .date span {
      color: $color-grey-label;
    }
  }

  .ob-func-panel__controls {
    justify-content: flex-start;
  }

  .ob-func-panel__controls-side:nth-child(2) {
    flex-grow: 1;
  }

  .ob-func-panel__control:last-child {
    margin-left: auto;
  }

  .ob-func-panel__control-row {
    color: $color-blue-smalt;

    .icon:before {
      color: $color-blue-smalt;
    }
  }
}
</style>